#!/usr/bin/python3
# -*- coding: UTF-8 -*-
import os
import re
import json
# import codecs
# def read_json(item):
#     with codecs.open(item, 'r', 'utf-8-sig') as f:
#         return json.load(f)

MODEL_PATH = 'resource/image_native/live2d_v4/'
dl = os.listdir(MODEL_PATH)
dl.sort()
models = {}
chars = {}
for m in dl:
    # params = read_json(MODEL_PATH + m + "/params.json")
    # charaName = params["charaName"]
    if not os.path.isdir(MODEL_PATH + m): continue
    ch = int(m[0:-2])
    with os.popen('grep charaName ' + MODEL_PATH + m + '/params.json | cut -d \'"\' -f 4 | sed \'s/　/ /g\'') as f:
        charaName = f.read().strip().replace('(圧縮)', '').replace('（圧縮）', '').replace('_圧縮', '').strip('_圧縮').replace(' ', '')
        name = charaName.split('_')[0].split('(')[0].split('（')[0]
    custom = re.search(r'[(（](.*?)[)）](.*)', charaName)
    if not name in chars and os.path.isdir(MODEL_PATH + m[0:-2] + '00'):
        with os.popen('grep charaName ' + MODEL_PATH + m[0:-2] + '00/params.json | cut -d \'"\' -f 4 | sed \'s/　/ /g\'') as f:
            name = f.read().rstrip().rstrip('圧縮').split('_')[0].split('(')[0].split('（')[0].replace(' ', '')
    custom = (custom.group(1) + '_' + custom.group(2)) if custom else charaName.lstrip(name)
    custom = custom.strip('_').replace('__', '_').replace('._', '.') if custom else charaName
    if not ch in models:
        if name in chars:
            if chars[name] > ch:
                models[ch] = models.pop(chars[name])
                chars[name] = ch
            else:
                if chars[name] < ch: ch = chars[name]
        else:
            chars[name] = ch
            models[ch] = {'name': name, 'models': {}}
    models[ch]['models'][int(m)] = custom
    # models[ch]['models'][int(m[-2:])] = {'name': custom, 'id': m}

with open(MODEL_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(models, f, ensure_ascii=False, indent=4, sort_keys=True)

VOICE_PATH = 'resource/sound_native/voice/'
dl = os.listdir(VOICE_PATH)
voices = {'char': {}, 'game': {}, 'kyube': {}}
for m in dl:
    vo = re.match(r'^vo_([a-zA-Z]+?)_(.+)_hca\.hca$', m)
    if not vo: continue
    char = vo.group(1)
    if char == "char":
        id = re.search(r'(\d+)_(\d+)_(\d+)', vo.group(2))
        ch = id.group(1)
        custom = id.group(2)
        id = id.group(3)
        if not ch in voices['char']:
            voices['char'][ch] = {}
        if not custom in voices['char'][ch]:
            voices['char'][ch][custom] = {}
        voices['char'][ch][custom][id] = m[:-4]
    elif char == "game":
        id = re.search(r'(\d+)_(\d+)', vo.group(2))
        ch = id.group(1)
        id = id.group(2)
        if not ch in voices['game']:
            voices['game'][ch] = {}
        voices['game'][ch][id] = m[:-4]
    elif char == "kyube":
        id = re.search(r'(\d+)_(\d+)', vo.group(2))
        ch = id.group(1)
        id = id.group(2)
        if not ch in voices['kyube']:
            voices['kyube'][ch] = {}
        voices['kyube'][ch][id] = m[:-4]

with open(VOICE_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(voices, f, ensure_ascii=False, indent=4, sort_keys=True)

BG_PATH = 'resource/image_native/bg/'
background = {'quest': {}, 'quest_top': {}, 'story': {}, 'web': {}}
dl = os.listdir(BG_PATH + 'quest/')
for m in dl:
    name = re.match(r'^bg_quest_(\d+)(_effect(\d+))?\.png$', m)
    if not name: continue
    ids = name.group(1)
    app = name.group(2)
    fam = ids[:-1]
    sub = ids[-1]
    if not fam in background['quest']: background['quest'][fam] = {}
    if not sub in background['quest'][fam]: background['quest'][fam][sub] = { 'main': None }
    if not app: background['quest'][fam][sub]['main'] = m
    else:
        if not 'effect' in background['quest'][fam][sub]: background['quest'][fam][sub]['effect'] = []
        background['quest'][fam][sub]['effect'].append(m)
dl = os.listdir(BG_PATH + 'quest_top/')
for m in dl:
    name = re.match(r'^bg_map_(\d+)\.png$', m)
    if not name: continue
    ids = name.group(1)
    background['quest_top'][ids] = m
dl = os.listdir(BG_PATH + 'story/')
for m in dl:
    name = re.match(r'^bg_adv_(\d+)\.jpg$', m)
    if not name: continue
    ids = name.group(1)
    fam = ids[:-1]
    sub = ids[-1]
    if not fam in background['story']: background['story'][fam] = {}
    background['story'][fam][sub] = m
dl = os.listdir(BG_PATH + 'web/')
background['web'] = { 'jpg': [] }
for m in dl:
    name = re.match(r'^web_(.*)\.(jpg|png)$', m)
    if not name: continue
    if name.group(2) == "jpg": background['web']['jpg'].append(m)
    else:
        continue
background['web']['jpg'].sort()

with open(BG_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(background, f, ensure_ascii=False, indent=4, sort_keys=True)

CG_PATH = 'resource/scenario/img/'
cg = { '': [], '.': {} }
dl = os.listdir(CG_PATH)
for m in dl:
    if os.path.isdir(CG_PATH + m): # Deep 1
        sdl = os.listdir(CG_PATH + m)
        if not len(sdl): continue
        if os.path.isdir(CG_PATH + m + '/' + sdl[0]): # Deep 2
            # 默认带子文件夹的全是文件夹
            cg[m] = {}
            for i in sdl:
                ssdl = os.listdir(CG_PATH + m + '/' + i)
                cg[m][i] = []
                for j in ssdl:
                    if re.match(r'^.*\.(jpg|png)$', j): cg[m][i].append(i + '/' + j)
                cg[m][i].sort()
        else:
            cg[m] = []
            for i in sdl:
                if re.match(r'^.*\.(jpg|png)$', i): cg[m].append(i)
            cg[m].sort()
    elif re.match(r'^.*\.(jpg|png)$', m):
        adv = re.match(r'(adv_.*)_(\d+)\.', m)
        if adv:
            if not adv.group(1) in cg['.']: cg['.'][adv.group(1)] = {}
            cg['.'][adv.group(1)][adv.group(2)] = m
        else: cg[''].append(m)
cg[''].sort()

with open(CG_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(cg, f, ensure_ascii=False, indent=4, sort_keys=True)

MOVIE_PATH = 'resource/movie/'
movie = {'char': {}, 'other': {}, 'mini': {}}
dl = os.listdir(MOVIE_PATH + 'other/')
for m in dl:
    mo = re.match(r'^(.+?_)?(.+)\.usm$', m)
    if not mo: continue
    name = mo.group(1)[:-1]
    if not name in movie['other']: movie['other'][name] = []
    movie['other'][name].append(mo.group(0))
dl = os.listdir('resource/image_native/mini/movie/')
for m in dl:
    mo = re.match(r'^movie_([^_]+)(.+)\.usm$', m)
    if not mo: continue
    name = mo.group(1)
    if not name in movie['mini']: movie['mini'][name] = []
    movie['mini'][name].append(mo.group(0))
dl = os.listdir(MOVIE_PATH + 'char/')
for m in dl:
    mo = re.match(r'^movie_(\d+)(_\d+)?\.usm$', m)
    if not mo: continue
    char = mo.group(1)
    if not char in movie['char']: movie['char'][char] = []
    movie['char'][char].append(mo.group(0))
for i in movie['char']: movie['char'][i].sort()

with open(MOVIE_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(movie, f, ensure_ascii=False, indent=4, sort_keys=True)

SOUND_PATH = 'resource/sound_native/'
sound = {'bgm': {}, 'fullvoice': {}, 'jingle': {}, 'surround': {}, 'voice': {}}
dl = os.listdir(SOUND_PATH + 'bgm/')
for m in dl:
    bgm = re.match(r'^(bgm\d+)_([a-zA-Z]+\d+)(_.+)?_hca\.hca$', m)
    if not bgm: continue
    group = bgm.group(1)
    if not group in sound['bgm']: sound['bgm'][group] = []
    sound['bgm'][group].append(bgm.group(0))
for i in sound['bgm']: sound['bgm'][i].sort()
dl = os.listdir(SOUND_PATH + 'fullvoice/')
for m in dl:
    sl = os.listdir(SOUND_PATH + 'fullvoice/' + m)
    if not m in sound['fullvoice']: sound['fullvoice'][m] = []
    for n in sl:
        vo = re.match(r'^.+_hca\.hca$', n)
        if not vo: continue
        sound['fullvoice'][m].append(n)
for i in sound['fullvoice']: sound['fullvoice'][i].sort()
dl = os.listdir(SOUND_PATH + 'jingle/')
for m in dl:
    jg = re.match(r'^(\d+)(.+)_hca\.hca$', m)
    if not jg: continue
    group = jg.group(1)
    # sub = jg.group(2).strip('_')
    if not group in sound['jingle']: sound['jingle'][group] = []
    sound['jingle'][group].append(jg.group(0))
for i in sound['jingle']: sound['jingle'][i].sort()
dl = os.listdir(SOUND_PATH + 'surround/')
for m in dl:
    jg = re.match(r'^(\d+)(.+)_hca\.hca$', m)
    if not jg: continue
    group = jg.group(1)
    # sub = jg.group(2).strip('_')
    if not group in sound['surround']: sound['surround'][group] = []
    sound['surround'][group].append(jg.group(0))
for i in sound['surround']: sound['surround'][i].sort()
dl = os.listdir(SOUND_PATH + 'voice/')
for m in dl:
    vo = re.match(r'^vo_([a-zA-Z]+_\d+)_(.+)?_hca\.hca$', m)
    if not vo: continue
    group = vo.group(1)
    if not group in sound['voice']: sound['voice'][group] = []
    sound['voice'][group].append(vo.group(0))
for i in sound['voice']: sound['voice'][i].sort()

with open(SOUND_PATH + "list.json", 'w', encoding="UTF-8") as f:
    json.dump(sound, f, ensure_ascii=False, indent=4, sort_keys=True)
